package com.foreverwin.mesnac.anomaly.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.foreverwin.mesnac.anomaly.model.AbnormalBill;
import com.foreverwin.mesnac.anomaly.model.AbnormalBillDispose;
import com.foreverwin.mesnac.anomaly.model.AbnormalBillLog;
import com.foreverwin.mesnac.anomaly.service.AbnormalBillLogService;
import com.foreverwin.modular.core.util.FrontPage;
import com.foreverwin.modular.core.util.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 *
 * @author zjw
 * @since 2021-09-15
 */
@RestController
@RequestMapping("/Z-ABNORMAL-BILL-LOG")
public class AbnormalBillLogController {

    @Autowired
    public AbnormalBillLogService abnormalBillLogService;

    /**
    * 根据id查询
    *
    * @param id 主键
    * @return
    */
    @ResponseBody
    @GetMapping("/{id:.+}")
    public R getAbnormalBillLogById(@PathVariable String id) {
        return R.ok( abnormalBillLogService.getById(id));
    }

    /**
     * 查询所有数据
     *
     * @return
     */
    @ResponseBody
    @GetMapping("")
    public R getAbnormalBillLogList(AbnormalBillLog abnormalBillLog){
        List<AbnormalBillLog> result;
        QueryWrapper<AbnormalBillLog> queryWrapper = new QueryWrapper<>();
        queryWrapper.setEntity(abnormalBillLog);
        result = abnormalBillLogService.list(queryWrapper);
        return R.ok(result);
    }

    /**
     * 分页查询数据
     *
     * @param frontPage  分页信息
     * @return
     */
    @ResponseBody
    @GetMapping("/page")
    public R page(FrontPage<AbnormalBillLog> frontPage, AbnormalBillLog abnormalBillLog){
        IPage result;
        QueryWrapper<AbnormalBillLog> queryWrapper = new QueryWrapper<>();
        queryWrapper.setEntity(abnormalBillLog);
        if (frontPage.getGlobalQuery() != null && !"".equals(frontPage.getGlobalQuery().trim())) {
            //TODO modify global query
            queryWrapper.lambda().and(wrapper -> wrapper
                .like(AbnormalBillLog::getHandle, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getSite, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getAbnormalNo, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getStatus, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getType, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getItemBo, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getSfc, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getOperation, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getWorkCenter, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getShopOrder, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getMessageType, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getResrce, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getNcCode, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getNcCodeGroup, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getShutDown, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getResponseUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getPbDescription, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getNcQty, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getPbGrade, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getPbUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getPbQty, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getDiscover, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getInspector, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getEntityLocation, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getReportFrom, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getObjectBo, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getPbPhotoshop, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getCancelCode, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getCancelReason, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getCancelUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getDutyUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getDutyDepart, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getPrincipalUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getDutyCauseDescription, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getDutyCauseType, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getDutyType, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getDutySendUserGroup, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getResolveUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getAbnormalMethod, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getRouterBo, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getResolveShopOrder, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getResolveRemark, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getResolveSendUserGroup, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getClosedUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getAbnormalReason, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getBeforeMeasure, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getReportSendUserGroup, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getCancelSendUserGroup, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getCreatedUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getModifiedUser, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getProductCategory, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getStepId, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getWorkOrder, frontPage.getGlobalQuery())
                .or().like(AbnormalBillLog::getItemNumber, frontPage.getGlobalQuery())
    );
        }
        result = abnormalBillLogService.page(frontPage.getPagePlus(), queryWrapper);
        return R.ok(result);
    }

    /**
     * 新增
     * @param abnormalBillLog  传递的实体
     * @return  null 失败  实体成功
     */
    @PostMapping
    public R save(@RequestBody AbnormalBillLog abnormalBillLog) {
        return R.ok(abnormalBillLogService.save(abnormalBillLog));
    }

    /**
     * 修改
     * @param abnormalBillLog  传递的实体
     * @return  null 失败  实体成功
     */
    @PutMapping
    public R updateById(@RequestBody AbnormalBillLog abnormalBillLog) {
        return R.ok(abnormalBillLogService.updateById(abnormalBillLog));
    }

    /**
     * 根据id删除对象
     * @param id  实体ID
     * @return 0 失败  1 成功
     */
    @ResponseBody
    @RequestMapping(method = RequestMethod.DELETE, value = "/{id:.+}")
    public R removeById(@PathVariable("id") String id){
        return R.ok(abnormalBillLogService.removeById(id));
    }

    /**
     * 批量删除对象
     * @param ids 实体集合ID
     * @return  0 失败  1 成功
     */
    @ResponseBody
    @RequestMapping(method = RequestMethod.POST, value = "/delete-batch")
    public R removeByIds(List<String> ids){
        return R.ok(abnormalBillLogService.removeByIds(ids));
    }

    @GetMapping("/saveAndUpdate")
    public R saveAndUpdate(AbnormalBill abnormalBill,
                           AbnormalBillDispose abnormalBillDispose,
                           @RequestParam List<String> ncGroupAndNcCodes,
                           @RequestParam List<String> dutyCauseType,
                           @RequestParam List<String> dutyType){
        abnormalBillLogService.saveAndUpdate(abnormalBill,abnormalBillDispose,ncGroupAndNcCodes,dutyCauseType,dutyType);
        return R.ok();
    }

}